unit QuickRTTI;

interface
uses classes,typinfo,sysutils,lowx;

type
{
This file is released under an MIT style license as detailed at opensource.org.
Just don't preteend you wrote it, and leave this comment in the text, and
I'll be happy.  Consider it my resume :)

April 17,2000 Michael Johnson
 father@bigattichouse.com
 www.bigattichouse.com

Quick RTTI gives you simple string based access to RTTI data in any
RTTI capable component.  WIth the addition of my lowx and strutils you
can also read and write basic XML structures based off of your component.
SUPER easy.

Just set RTTIObject:= some TPersistent descendant (any TComponent) and you will have
nice string based access to all its fields by name... cool huh.

I am testing an "Object Shell" that will allow using QuickRTTI and
Toadbase to use/store RTTI Objects thru memory mapped files, ie..
web based persistence.. I know, why not use CORBA..

 hell, in the
words of Disney via Mr W.T.Pooh "...I wouldn't climb this tree / if a bear
flew like a bee / but I wouldn't be a bear then / so I guess I wouldn't
care then..."

Perhaps having the simple ability to convert TComponents to and from XML
will open up a new world for delphi... now to work on RPC !..
}
TQuickRTTI = class (TPersistent)
 private
  fobj:TPersistent; PList:PPropList;
  props:tstringlist; fval:String;
 protected
   function outputXML :String;
   procedure inputXML (sXML:String);
   procedure SetValue (Fieldname:String;Value:String);
   function GetValue (Fieldname:String):String;
   procedure SetObject (o:TPersistent);
 public
   function propertyCount:integer;
   function indexof(name:String):Integer;
   function propertynames(index:integer):String;
   function propertyVarTypes(index:integer):String;
   property Value[Fieldname:String]:String read GetValue write SetValue;
 published
   property RTTIObject:TPersistent read fobj write SetObject;
   property XML:String read outputXML write inputXML;
 end;


implementation

procedure TQuickRTTI.SetObject (o:TPersistent);
var PTI:PTypeInfo;List:TPropList;
   Tinfo:TPropInfo;   i :integer;   vin:variant;
begin
if not(assigned(props)) then props:=tstringlist.create;
props.clear;
fobj:=o;
PTI:=o.ClassInfo ;
PList:= @List;
i:= GetPropList(PTI,[tkClass,tkInteger, tkChar, tkEnumeration, tkFloat,
    tkString, tkSet, tkClass, tkMethod, tkWChar, tkLString, tkWString,
    tkVariant, tkArray, tkRecord, tkInterface, tkInt64],
    PList);
{getting the list... but I'm pretty much trying to ignore
method calls for this version}
for i:= 0 to 255 do
if  assigned(Plist[i]) then
 begin
   Tinfo:= Plist[i]^;
   vin:=GetPropValue(fobj,Tinfo.Name,True);
   props.addobject(Uppercase(Tinfo.Name), Pointer(PList[i]) );
 end;
end;

function TQuickRTTI.propertyCount:integer;
begin
result:=-1;
if assigned(props) then result:=props.count;
end;


function TQuickRTTI.propertynames(index:integer):String;
begin
result:='';
if assigned(props) then result:=props[index];
end;

function TQuickRTTI.indexof(name:String):Integer;
begin
if assigned(props) then result:=props.IndexOf (Uppercase(name));
end;

function TQuickRTTI.propertyVarTypes(index:integer):string;
var Tinfo:TPropInfo;
begin
result:='';
if assigned(props) then
begin
  Tinfo:=TPropinfo(Pointer(props.objects[index])^);
  result:=Tinfo.PropType^.name;
end;

end;

procedure TQuickRTTI.SetValue (Fieldname:String;Value:String);
var  vin:Variant; fname:Shortstring;
begin
   fname:=fieldname;
   Vin:=Value;
   SetPropValue(fobj,fName,Vin);
end;

function TQuickRTTI.GetValue (Fieldname:String):String;
var v,vin:Variant; fname:Shortstring;
begin
   fname:=fieldname;
   vin:=GetPropValue(fobj,fName,True);
   Varcast(v,vin,varString);
   result:=vin;
end;

function TQuickRTTI.outputXML :String;
var i:integer;
begin
result:='<'+fobj.ClassName+'>'+#13+#10;
 for i:= 0 to props.count-1 do
 begin
  result:=result+' <'+props[i]+'>'+GetValue(propertynames(i))+'</'+props[i]+'>'+#13+#10;
 end;
result:=result+'</'+fobj.ClassName+'>'+#13+#10;
end;

procedure TQuickRTTI.inputXML (sXML:String);
var thisclass,thisobj:String; i:integer;
begin
{OK.. I could get a whole list of objects.. but since
I'm delaing with em one at a time..}
thisclass:= fobj.ClassName;
thisobj:=GetTagString (sXML,thisclass);
{Now let RTTI discover itself in the XML!}
for i:= 0 to props.count-1 do
 begin
  SetValue(props[i],GetTagData(thisobj,props[i]));
 end;
end;

end.
